class Tabloc {
  constructor(pref) {
    this.pref = pref;
  }

  getBoolPref(key) {
    const value = this.pref[key];
    if (value == undefined) {
      switch (key) {
        case "ex_inpagelink": return true;
        case "ex_formsubmit": return false;
      }
    }
    if(value == "false"){
      return false;
    }
    return value;
  }

  onclick(evt) {
    if (!evt || !evt.target || evt.button != 0){
      return;
    }
    let a = evt.target;
    while (a && !a.href && a.tagName && (a.tagName.toLowerCase() != "form")) {
      a = a.parentNode;
    }

    if (a && a.href) {
      this.href(a, evt);
    } else if (a && a.tagName && a.tagName.toLowerCase() === "form") {
      this.form(a, evt);
    }
  }

  href(a, evt) {
    if (a.href.indexOf("javascript:") == 0) {
      return;
    }
    if (this.getBoolPref("ex_inpagelink")) {
      const targetHref = this.getTargetURL(a).split("#")[0];
      if (a.href === targetHref || a.href.indexOf(targetHref + "#") == 0) {
        return;
      }
    }

    chrome.runtime.sendMessage({
      command: "createTab",
      url: a.href
    });

    evt.stopPropagation();
    evt.preventDefault();
  }

  getTargetURL(a) {
    const target = a.target;
    if (target == null || target == "" || target == "_self") {
      return a.ownerDocument.URL;
    } else if (target == "_blank") {
      return "";
    } else if (target == "_top") {
      return window.location.href;
    } else {
      const frames = window.frames;
      for (const i=0; i<frames.length; i++) {
        if (frames[i].name == target) {
          return frames[i].location.href;
        }
      }
    }
    return a.ownerDocument.URL;
  }

  form(a, evt) {
    if (this.getBoolPref("ex_formsubmit")) {
      return;
    }
    a.setAttribute("__tabloc_target", a.target || '');
    a.target = "_blank";
    window.setTimeout(() => {
      if (a.hasAttribute("__tabloc_target")) {
        a.target = a.getAttribute("__tabloc_target");
        a.removeAttribute("__tabloc_target");
      }
    }, 500);
  }
}

var listener = null;

chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.command == "lockTab") {
    window.removeEventListener("click", listener, true);
    const tabloc = new Tabloc(message);
    listener = (evt) => tabloc.onclick(evt);
    window.addEventListener("click", listener, true);
    if (!document.title.startsWith(message.ic_emoji)) {
      document.title = message.ic_emoji + document.title;
    }
    sendResponse({result: "ok"});
  } else if (message.command == "unlockTab") {
    window.removeEventListener("click", listener, true);
    if (document.title.startsWith(message.ic_emoji)) {
      document.title = document.title.substr(message.ic_emoji.length);
    }
    sendResponse({result: "ok"});
  } else {
    sendResponse({});
  }
});
